class Move:
    NETSTR_LEN = 5
    def __init__(self, frm, to, queenPiece='q'):
	self.frm = tuple(frm)
	self.to = tuple(to)
	self.queenPiece = queenPiece
    def netStrCoord(self, coord):
	assert coord[0] < 256 - ord('a')
	assert coord[1] < 256 - ord('1')
	return "%s%s" % (chr(ord('a') + coord[0]),
		chr(ord('1') + coord[1]))
    def netStr(self):
	return "%s%s%s" % (self.netStrCoord(self.frm),
		self.netStrCoord(self.to), self.queenPiece)
    def niceStr(self):
	def niceStrCoord(coord):
	    return "%s%s" % (chr(ord('a') + coord[0]),
		    chr(ord('1') + coord[1]))
	s = niceStrCoord(self.frm) + niceStrCoord(self.to)
	return s
    def __str__(self):
	return self.netStr()
class Choice:
    NETSTR_LEN = 10
    def __init__(self, primary, secondary=None):
	self.primary = primary
	self.secondary = secondary
    def netStr(self):
	pstr = self.primary.netStr()
	if self.secondary:
	    sstr = self.secondary.netStr()
	else: sstr = " "*5
	return pstr+sstr
    def niceStr(self):
	pstr = self.primary.niceStr()
	if self.secondary:
	    return pstr + " / " + self.secondary.niceStr()
	else:
	    return pstr
    def __str__(self):
	return self.netStr()


def netStrToChoice(str):
    assert len(str) == Choice.NETSTR_LEN
    def coord(s):
	return (ord(s[0]) - ord('a'),
		ord(s[1]) - ord('1'))
    primary = Move(coord(str[0:2]), coord(str[2:4]), str[4])
    if str[5] == ' ':
	secondary = None
    else:
	secondary = Move(coord(str[5:7]), coord(str[7:9]), str[9])
    return Choice(primary, secondary)
